package org.osmandroid.samples;

import org.osmandroid.samples.R;
import org.osmandroid.samples.R.color;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.net.Socket;
import java.net.UnknownHostException;
import java.util.ArrayList;

import android.app.Activity;
import android.content.ContentResolver;
import android.content.Context;
import android.graphics.Bitmap;
import android.graphics.drawable.BitmapDrawable;
import android.graphics.BitmapFactory;
import android.graphics.Color;
import android.location.Location;
import android.location.LocationListener;
import android.location.LocationManager;
import android.os.Bundle;
import android.os.Handler;
import android.os.Message;
import android.provider.Settings.SettingNotFoundException;
import android.provider.Settings.System;
import android.util.Log;
import android.view.Gravity;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.view.Window;
import android.view.View.OnClickListener;
import android.widget.AbsoluteLayout;
import android.widget.Button;
import android.widget.FrameLayout;
import android.widget.ImageView;
import android.widget.RelativeLayout;
import android.widget.SeekBar;
import android.widget.TextView;
import android.widget.Toast;
import android.widget.ZoomControls;
import android.widget.SeekBar.OnSeekBarChangeListener;
import android.view.WindowManager.LayoutParams;
import android.view.animation.Animation;
import android.view.animation.Animation.AnimationListener;
import android.view.animation.AnimationUtils;
import android.view.animation.DecelerateInterpolator;
import android.view.animation.TranslateAnimation;
import android.widget.LinearLayout;

import org.osmdroid.tileprovider.tilesource.CloudmadeTileSource;
import org.osmdroid.tileprovider.util.CloudmadeUtil;
import org.osmdroid.tileprovider.tilesource.TileSourceFactory;
import org.osmdroid.util.GeoPoint;
import org.osmdroid.views.MapView;
import org.osmdroid.views.MapController;
import org.osmdroid.views.overlay.ItemizedIconOverlay;
import org.osmdroid.views.overlay.OverlayItem;
import org.osmdroid.DefaultResourceProxyImpl;
import org.osmdroid.ResourceProxy;

public class MapOSM extends Activity implements LocationListener {
	/** Called when the activity is first created. */
	// Map stuff
	private MapController mapController;
	private MapView mapView;
	//private CloudmadeTileSource cmMap;
	private GeoPoint point;
	final ArrayList<OverlayItem> items = new ArrayList<OverlayItem>();
	final ArrayList<OverlayItem> itemsAlias = new ArrayList<OverlayItem>();
	private ItemizedIconOverlay<OverlayItem> mMyLocationOverlay;
	private ItemizedIconOverlay<OverlayItem> mMyLocationOverlayAlias;
	private ResourceProxy mResourceProxy;
	private Bitmap bubbleIcon;
	private Bitmap greenBubble;
	public boolean locationShown = false;
	public boolean enemyShown = false;
	public boolean aliasShown = false;

	// brightness seek bar
	private SeekBar brightbar;
	private int brightness;
	// the content resolver used as a handle to the system's settings
	private ContentResolver cResolver;
	// a window object, that will store a reference to the current window
	private Window window;

	ZoomControls zoomControls;

	// ******** Information and button bar************//
	FrameLayout informationBar = null;
	RelativeLayout buttonBar = null;
	private ImageView openInfoBar = null;
	private ImageView openButtonBar = null;
	int color0 = Color.BLACK;
	public TextView informationText = null;

	// message handler
	private Handler mainHandler;
	private String sndr_context;
	LayoutInflater inflater;
	View toast_layout;
	TextView message_text;
	Toast toast;
	ImageView toastImage;
	String [] dividedMessage ={ "","","","",""};
	

	// Buttons
	private ImageView zoom_button;
	private ImageView brightness_button;
	private ImageView message_button;
	private ImageView enemyButton;
	private ImageView aliasButton;
	private ImageView locationButton;

	private RelativeLayout buttonLayout;
	
	private Animation animScale;
	private Animation a;
	private Animation unscale;
	
	private int repeat = 1;
	private int size = 70;
	
	///Controller variables
	private int motionArray [] = new int [25];
	private int lightArray [] = new int [25];
	private int lastMotionValue = 0;
	private int lastLightValue = 0;
	private int index = 0;


	// Style Array
	private CloudmadeTileSource styles[][] = new CloudmadeTileSource[3][4];

	@Override
	public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.main);
		mResourceProxy = new DefaultResourceProxyImpl(getApplicationContext());
		
		//filling controller arrays
		for (int i = 0; i< 25; i++)
		{
			motionArray[i] = 0;
			lightArray[i] = 0;
		}
		
		// ************Getting UI Components from main.xml************************//
		enemyButton = (ImageView) findViewById(R.id.enemy);
		aliasButton = (ImageView) findViewById(R.id.alias);
		message_button = (ImageView) this.findViewById(R.id.message);
		informationBar = (FrameLayout) findViewById(R.id.informationBar);
		buttonBar = (RelativeLayout) findViewById(R.id.frameButtonBar);
		informationText = (TextView) findViewById(R.id.name);
		openInfoBar = (ImageView) findViewById(R.id.openInfoBar);
		openButtonBar = (ImageView) findViewById(R.id.openButtonBar);
		brightness_button = (ImageView) this.findViewById(R.id.brightness);
		brightbar = (SeekBar) findViewById(R.id.sb_brightbar);
		zoom_button = (ImageView) this.findViewById(R.id.zoom);
		buttonLayout = (RelativeLayout) findViewById(R.id.button_bar);
		locationButton = (ImageView) findViewById(R.id.location);
		animScale = AnimationUtils.loadAnimation(this, R.anim.scale);
		unscale = AnimationUtils.loadAnimation(this, R.anim.unscale);

		//**** message toast components
		inflater = getLayoutInflater();
		toast_layout = inflater.inflate(R.layout.toast_layout,
		                           (ViewGroup) findViewById(R.id.toast_layout_root));
		
		toastImage = (ImageView) toast_layout.findViewById(R.id.image);
		toastImage.setImageResource(R.drawable.message);
		message_text = (TextView) toast_layout.findViewById(R.id.text);
		message_text.setText("");
		toast = new Toast(getApplicationContext());
		toast.setGravity(Gravity.CENTER, 0, 0);
		toast.setDuration(Toast.LENGTH_LONG);
		toast.setView(toast_layout);
		
		//String x = "Ali |Tehlike! |Hemen Gel. |Beni ara. |ptm";
		//dividedMessage = x.split("\\|");
		
		
		// ************Setting up the Styles************************//
		// Light Condition 1 and their movement variants
		CloudmadeUtil.retrieveCloudmadeKey(getApplicationContext());
		String token =CloudmadeUtil.getCloudmadeToken();
		styles[0][0] = new CloudmadeTileSource( "1_1", ResourceProxy.string.cloudmade_standard, 0, 18, 256, ".png",
												"http://a.tile.cloudmade.com/%s/%d/%d/%d/%d/%d%s?token=%s");
		styles[0][0].setStyle(37554);
		styles[0][1] =  new CloudmadeTileSource( "1_1", ResourceProxy.string.cloudmade_standard, 0, 18, 256, ".png",
												"http://a.tile.cloudmade.com/%s/%d/%d/%d/%d/%d%s?token=%s");
		styles[0][1].setStyle(37587);
		styles[0][2] = new CloudmadeTileSource( "1_1", ResourceProxy.string.cloudmade_standard, 0, 18, 256, ".png",
												"http://a.tile.cloudmade.com/%s/%d/%d/%d/%d/%d%s?token=%s");
		styles[0][2].setStyle(37594);
		styles[0][3] =  new CloudmadeTileSource( "1_1", ResourceProxy.string.cloudmade_standard, 0, 18, 256, ".png",
												"http://a.tile.cloudmade.com/%s/%d/%d/%d/%d/%d%s?token=%s");
		styles[0][3].setStyle(37599);
		// Light Condition 2 and their movement variants
		styles[1][0] =  new CloudmadeTileSource( "1_1", ResourceProxy.string.cloudmade_standard, 0, 18, 256, ".png",
												"http://a.tile.cloudmade.com/%s/%d/%d/%d/%d/%d%s?token=%s");
		styles[1][0].setStyle(37560);
		styles[1][1] =  new CloudmadeTileSource( "1_1", ResourceProxy.string.cloudmade_standard, 0, 18, 256, ".png",
												"http://a.tile.cloudmade.com/%s/%d/%d/%d/%d/%d%s?token=%s");
		styles[1][1].setStyle(37588);
		styles[1][2] =  new CloudmadeTileSource( "1_1", ResourceProxy.string.cloudmade_standard, 0, 18, 256, ".png",
												"http://a.tile.cloudmade.com/%s/%d/%d/%d/%d/%d%s?token=%s");
		styles[1][2].setStyle(37593);
		styles[1][3] =  new CloudmadeTileSource( "1_1", ResourceProxy.string.cloudmade_standard, 0, 18, 256, ".png",
												"http://a.tile.cloudmade.com/%s/%d/%d/%d/%d/%d%s?token=%s");
		styles[1][3].setStyle(37598);
		// Light Condition 2 and their movement variants
		styles[2][0] =  new CloudmadeTileSource( "1_1", ResourceProxy.string.cloudmade_standard, 0, 18, 256, ".png",
												"http://a.tile.cloudmade.com/%s/%d/%d/%d/%d/%d%s?token=%s");
		styles[2][0].setStyle(37567);
		styles[2][1] =  new CloudmadeTileSource( "1_1", ResourceProxy.string.cloudmade_standard, 0, 18, 256, ".png",
												"http://a.tile.cloudmade.com/%s/%d/%d/%d/%d/%d%s?token=%s");
		styles[2][1].setStyle(37591);
		styles[2][2] =  new CloudmadeTileSource( "1_1", ResourceProxy.string.cloudmade_standard, 0, 18, 256, ".png",
												"http://a.tile.cloudmade.com/%s/%d/%d/%d/%d/%d%s?token=%s");
		styles[2][2].setStyle(37597);
		styles[2][3] =  new CloudmadeTileSource( "1_1", ResourceProxy.string.cloudmade_standard, 0, 18, 256, ".png",
												"http://a.tile.cloudmade.com/%s/%d/%d/%d/%d/%d%s?token=%s");
		styles[2][3].setStyle(37603);

		// ************Setting up the Map************************//
		mapView = (MapView) findViewById(R.id.myMap);
		mapController = mapView.getController();
		mapView.setTileSource(styles[0][0]);
		mapController.setZoom(7);
		GeoPoint point = new GeoPoint(51496994, -134733);
		mapController.setCenter(point);
		
		//Default motion = 0 , light= 0//
		changeStyleMotion(0, 0);
		changeStyleLight(0, 0);
		decideButtons(0, 0);
		
		// ************Adding Enemy and Alias************************//
		bubbleIcon = BitmapFactory.decodeResource(this.getResources(),
				R.drawable.bubble);
		greenBubble = BitmapFactory.decodeResource(this.getResources(),
				R.drawable.bubblegreen);
		BitmapDrawable drawableBubble = new BitmapDrawable(bubbleIcon);
		BitmapDrawable drawableGreenBubble = new BitmapDrawable(greenBubble);

		// *********************************************************************//
		// *******************************Enemy
		// List****************************//
		// *********************************************************************//
		items.add(new OverlayItem("Enemy-X", "SampleDescription", point));
		items.add(new OverlayItem("Enemy-Y", "SampleDescription", new GeoPoint(
				51656884, -136737)));
		items.add(new OverlayItem("Enemy-Z", "SampleDescription", new GeoPoint(
				55746774, -147728)));
		items.add(new OverlayItem("Enemy-W", "SampleDescription", new GeoPoint(
				58836664, -148719)));

		// *********************************************************************//
		// *******************************Alias
		// List****************************//
		// *********************************************************************//
		itemsAlias.add(new OverlayItem("Alias-A", "SampleDescription",
				new GeoPoint(52495994, -124173)));
		itemsAlias.add(new OverlayItem("Alias-B", "SampleDescription",
				new GeoPoint(54494994, -155243)));
		itemsAlias.add(new OverlayItem("Alias-C", "SampleDescription",
				new GeoPoint(56493994, -176353)));
		itemsAlias.add(new OverlayItem("Alias-D", "SampleDescription",
				new GeoPoint(59492994, -187463)));

		// *********************************************************************//
		// *******************************Enemy
		// Overlay*************************//
		// *********************************************************************//
		this.mMyLocationOverlay = new ItemizedIconOverlay<OverlayItem>(items,
				drawableBubble,
				new ItemizedIconOverlay.OnItemGestureListener<OverlayItem>() {
					@Override
					public boolean onItemSingleTapUp(final int index,
							final OverlayItem item) {
						String information = new String();
						information = information.concat("\n\n");
						information = information.concat(" NAME: \n\n");
						information = information.concat("    ");
						information = information.concat(item.mTitle);
						information = information.concat("\n\n");
						information = information.concat(" COORDINATES: \n\n");
						information = information.concat("    X: ");
						information = information.concat(new Integer(
								item.mGeoPoint.getLatitudeE6()).toString());
						information = information.concat("\n\n");
						information = information.concat("    Y: ");
						information = information.concat(new Integer(
								item.mGeoPoint.getLongitudeE6()).toString());
						information = information.concat("\n");
						informationText.setText(information);
						informationBar.setVisibility(View.VISIBLE);				
						int resid = R.drawable.larrow;
						openInfoBar.setImageResource(resid);
						// Toast.makeText( MapOSM.this, "Item '" + item.mTitle +
						// "' (index=" + index
						// + ") got single tapped up",
						// Toast.LENGTH_LONG).show();

						return true; // We 'handled' this event.
					}

					@Override
					public boolean onItemLongPress(final int index,
							final OverlayItem item) {
						String information = new String();
						information = information.concat("\n\n");
						information = information.concat("  NAME: \n\n");
						information = information.concat("    ");
						information = information.concat(item.mTitle);
						information = information.concat("\n\n");
						information = information.concat(" COORDINATES: \n\n");
						information = information.concat("    X: ");
						information = information.concat(new Integer(
								item.mGeoPoint.getLatitudeE6()).toString());
						information = information.concat("\n\n");
						information = information.concat("    Y: ");
						information = information.concat(new Integer(
								item.mGeoPoint.getLongitudeE6()).toString());
						information = information.concat("\n");
						informationText.setText(information);
						informationBar.setVisibility(View.VISIBLE);	
						int resid = R.drawable.larrow;
						openInfoBar.setImageResource(resid);

						return false;
					}
				}, mResourceProxy);
		// *********************************************************************//
		// *****************************Alias
		// Overlay***************************//
		// *********************************************************************//
		this.mMyLocationOverlayAlias = new ItemizedIconOverlay<OverlayItem>(
				itemsAlias, drawableGreenBubble,
				new ItemizedIconOverlay.OnItemGestureListener<OverlayItem>() {
					@Override
					public boolean onItemSingleTapUp(final int index,
							final OverlayItem item) {
						String information = new String();
						information = information.concat("\n\n");
						information = information.concat(" NAME: \n\n");
						information = information.concat("    ");
						information = information.concat(item.mTitle);
						information = information.concat("\n\n");
						information = information.concat(" COORDINATES: \n\n");
						information = information.concat("    X: ");
						information = information.concat(new Integer(
								item.mGeoPoint.getLatitudeE6()).toString());
						information = information.concat("\n\n");
						information = information.concat("    Y: ");
						information = information.concat(new Integer(
								item.mGeoPoint.getLongitudeE6()).toString());
						information = information.concat("\n");
						informationText.setText(information);
						informationBar.setVisibility(View.VISIBLE);
						int resid = R.drawable.larrow;
						openInfoBar.setImageResource(resid);
						return true; // We 'handled' this event.
					}

					@Override
					public boolean onItemLongPress(final int index,
							final OverlayItem item) {
						String information = new String();
						information = information.concat("\n\n");
						information = information.concat(" NAME: \n\n");
						information = information.concat("    ");
						information = information.concat(item.mTitle);
						information = information.concat("\n\n");
						information = information.concat(" COORDINATES: \n\n");
						information = information.concat("    X: ");
						information = information.concat(new Integer(
								item.mGeoPoint.getLatitudeE6()).toString());
						information = information.concat("\n\n");
						information = information.concat("    Y: ");
						information = information.concat(new Integer(
								item.mGeoPoint.getLongitudeE6()).toString());
						information = information.concat("\n");
						informationText.setText(information);
						informationBar.setVisibility(View.VISIBLE);
						int resid = R.drawable.larrow;
						openInfoBar.setImageResource(resid);

						return false;
					}
				}, mResourceProxy);

		mMyLocationOverlay.setEnabled(enemyShown);
		mMyLocationOverlayAlias.setEnabled(aliasShown);
		this.mapView.getOverlays().add(this.mMyLocationOverlay);
		this.mapView.getOverlays().add(this.mMyLocationOverlayAlias);

		// ********** Enemy and Alias Buttons************//
		enemyButton.setOnClickListener(new View.OnClickListener() {
			@Override
			public void onClick(View v) {
				enemyShown = !enemyShown;
				if (enemyShown) {
					int resid = R.drawable.enemyac;
					enemyButton.setImageResource(resid);
				} else {
					int resid = R.drawable.enemypas;
					enemyButton.setImageResource(resid);
				}
				mMyLocationOverlay.setEnabled(enemyShown);
				mapView.invalidate();
			}
		});

		aliasButton.setOnClickListener(new View.OnClickListener() {
			@Override
			public void onClick(View v) {
				aliasShown = !aliasShown;
				if (aliasShown) {
					int resid = R.drawable.allyac;
					aliasButton.setImageResource(resid);
				} else {
					int resid = R.drawable.allypas;
					aliasButton.setImageResource(resid);
				}
				mMyLocationOverlayAlias.setEnabled(aliasShown);
				mapView.invalidate();

			}
		});

		// *********Messaging*************//
		mainHandler = new Handler() {

			public void handleMessage(Message msg) {
				
				String message = (msg.obj).toString();
				Log.i("delideli", message);
				
				int motionValue = 0, lightValue = 0;

				if (message.contains("&")) 
				{
					String[] temp = message.split("&");
					motionValue = Integer.parseInt(temp[0]);
					lightValue = Integer.parseInt(temp[1]);
					
					addArrays(motionValue, lightValue);
					changeContext();

				} 
				else if (message.contains("|"))
				{
					sndr_context = "";
					dividedMessage = message.split("\\|");
					if(motionValue == 0)
						sndr_context = sndr_context.concat("Sender: " + dividedMessage [0]
							+ "\n" + "Message: " + dividedMessage [1] + dividedMessage [2] +dividedMessage [3] +dividedMessage [4] );
					else if(motionValue == 1)
						sndr_context = sndr_context.concat("Sender: " + dividedMessage [0]
					        + "\n" + "Message: " + dividedMessage [1] + dividedMessage [2] +dividedMessage [3]  );
					else if(motionValue == 2)
						sndr_context = sndr_context.concat("Sender: " + dividedMessage [0]
						    + "\n" + "Message: " + dividedMessage [1] + dividedMessage [2] );
					else if (motionValue == 3)
						sndr_context = sndr_context.concat("Sender: " + dividedMessage [0]
						    + "\n" + "Message: " + dividedMessage [1] );
					message_text.setText(sndr_context);
					informationBar.setVisibility(View.GONE);
					int resid = R.drawable.rarrow;
					openInfoBar.setImageResource(resid);
				    toast.show();
				} 

			}
		};

		MessageHandler childThread = new MessageHandler(mainHandler);
		childThread.start();

		ContextControl contextControl = new ContextControl(mainHandler);
		contextControl.start();

		// message button
		this.message_button.setOnClickListener(new OnClickListener() {
			@Override
			public void onClick(View v) 
			{
				//message_text.setText(sndr_context);
				//message_text.setText("Hello! This is a custom toast!");
				if ( ((String)message_text.getText()).compareTo("") != 0)
				{
					informationBar.setVisibility(View.GONE);
					int resid = R.drawable.rarrow;
					openInfoBar.setImageResource(resid);
					toast.show();
				}
			}
		});

		// **************** Add information and button bar********************//
		//informationBar.setBackgroundColor(color);
		informationBar.setVisibility(View.GONE);
		informationText.setTextColor(color0);

		buttonBar.setVisibility(View.VISIBLE);

		openInfoBar.setOnClickListener(new View.OnClickListener() {

			@Override
			public void onClick(View v) {
				if (informationBar.isShown()) {
					informationBar.setVisibility(View.GONE);
					
					int resid = R.drawable.rarrow;
					openInfoBar.setImageResource(resid);
				}
				else {
					informationBar.setVisibility(View.VISIBLE);
					
					int resid = R.drawable.larrow;
					openInfoBar.setImageResource(resid);
				}

			}
		});

		openButtonBar.setOnClickListener(new View.OnClickListener() {

			@Override
			public void onClick(View v) {
				if (buttonBar.isShown()) {
					buttonBar.setVisibility(View.GONE);

					int resid = R.drawable.rarrow;
					openButtonBar.setImageResource(resid);

				} else {
					int resid = R.drawable.larrow;
					openButtonBar.setImageResource(resid);
					buttonBar.setVisibility(View.VISIBLE);
				}
			}
		});

		locationButton.setOnClickListener(new View.OnClickListener() {

			@Override
			public void onClick(View v) {

				// TODO Auto-generated method stub

				locationShown = !locationShown;

				if (locationShown) {
					int resid = R.drawable.locationac;
					locationButton.setImageResource(resid);
				} else {
					int resid = R.drawable.locationpas;
					locationButton.setImageResource(resid);
				}

			}

		});

		// **************** Adding zoom controls to Map*************//
		final LinearLayout zoomLayout = (LinearLayout) findViewById(R.id.layout_zoom);
		zoomControls = new ZoomControls(this);
		zoomLayout.addView(zoomControls, new LinearLayout.LayoutParams(
				LayoutParams.WRAP_CONTENT, LayoutParams.WRAP_CONTENT));
		zoomLayout.setVisibility(View.INVISIBLE);

		// *****Zoom Button
		this.zoom_button.setOnClickListener(new OnClickListener() {
			@Override
			public void onClick(View v) {
				if (zoomLayout.getVisibility() == View.INVISIBLE)
					zoomLayout.setVisibility(View.VISIBLE);
				else
					zoomLayout.setVisibility(View.INVISIBLE);
			}
		});
		zoomControls.setOnZoomInClickListener(new OnClickListener() {
			@Override
			public void onClick(View v) {
				if (mapView.canZoomIn())
					mapController.zoomIn();
			}
		});
		zoomControls.setOnZoomOutClickListener(new OnClickListener() {
			@Override
			public void onClick(View v) {
				if (mapView.canZoomOut())
					mapController.zoomOut();
			}
		});

		// ***********Adding Brightness adjustment**************//
		brightbar.setKeyProgressIncrement(1);
		window = getWindow();
		cResolver = getContentResolver();
		try {
			// get the current system brightness
			brightness = System.getInt(cResolver, System.SCREEN_BRIGHTNESS);
		} catch (SettingNotFoundException e) {
			// throw an error case it couldn't be retrieved
			Log.e("Error", "Cannot access system brightness");
			e.printStackTrace();
		}
		// sets the progress of the seek bar based on the system's brightness
		brightbar.setProgress(brightness);

		// register OnSeekBarChangeListener, so it can actually change values
		brightbar.setOnSeekBarChangeListener(new OnSeekBarChangeListener() {
			@Override
			public void onStopTrackingTouch(SeekBar seekBar) {
				// set the system brightness using the brightness variable value
				System.putInt(cResolver, System.SCREEN_BRIGHTNESS, brightness);

				// preview brightness changes at this window
				// get the current window attributes
				LayoutParams layoutpars = window.getAttributes();
				// set the brightness of this window
				layoutpars.screenBrightness = brightness / (float) 255;
				// apply attribute changes to this window
				window.setAttributes(layoutpars);
				brightbar.setVisibility(View.GONE);
			}

			@Override
			public void onStartTrackingTouch(SeekBar seekBar) {
			}

			@Override
			public void onProgressChanged(SeekBar seekBar, int progress,
					boolean fromUser) {
				// sets the minimal brightness level
				// if seek bar is 20 or any value below
				if (progress <= 20) {
					// set the brightness to 20
					brightness = 20;
				} else // brightness is greater than 20
				{
					// sets brightness variable based on the progress bar
					brightness = progress;
				}
			}
		});

		// Brightness Button
		this.brightness_button.setOnClickListener(new OnClickListener() {
			@Override
			public void onClick(View v) {
				if (!brightbar.isShown())
					brightbar.setVisibility(View.VISIBLE);
				else
					brightbar.setVisibility(View.GONE);
			}
		});

		// *****Getting locationManager and reflecting changes over map if
		// distance travel by
		// user is greater than 500m from current location.
		LocationManager lm = (LocationManager) getSystemService(Context.LOCATION_SERVICE);
		lm.requestLocationUpdates(LocationManager.GPS_PROVIDER, 1000L, 500.0f,
				this);

		animScale.setAnimationListener(new AnimationListener() {
	        @Override
	        public void onAnimationEnd(Animation anim) {
	    		//buttonBar.clearAnimation();

	        	zoom_button.getLayoutParams().width = size;
	    		zoom_button.getLayoutParams().height = size;
	    		brightness_button.getLayoutParams().width = size;
	    		brightness_button.getLayoutParams().height = size;
	    		message_button.getLayoutParams().width = size;
	    		message_button.getLayoutParams().height = size;
	    		enemyButton.getLayoutParams().width = size;
	    		enemyButton.getLayoutParams().height = size;
	    		aliasButton.getLayoutParams().width = size;
	    		aliasButton.getLayoutParams().height = size;
	    		locationButton.getLayoutParams().width = size;
	    		locationButton.getLayoutParams().height = size;
	    		
	    		if(size == 100)
	    		{
	    			informationBar.setVisibility(View.GONE);
	    			buttonBar.setVisibility(View.GONE);
	    			int resid = R.drawable.rarrow;
					openInfoBar.setImageResource(resid);
					openButtonBar.setImageResource(resid);
	    		}
	    			
	    		buttonBar.requestLayout();
	    		
	        }

			@Override
			public void onAnimationRepeat(Animation animation) {
				// TODO Auto-generated method stub
				
			}

			@Override
			public void onAnimationStart(Animation animation) {
				// TODO Auto-generated method stub
				
			}
		});
		
		unscale.setAnimationListener(new AnimationListener() {
	        @Override
	        public void onAnimationEnd(Animation anim) {
	    		//buttonBar.clearAnimation();

	        	zoom_button.getLayoutParams().width = size;
	    		zoom_button.getLayoutParams().height = size;
	    		brightness_button.getLayoutParams().width = size;
	    		brightness_button.getLayoutParams().height = size;
	    		message_button.getLayoutParams().width = size;
	    		message_button.getLayoutParams().height = size;
	    		enemyButton.getLayoutParams().width = size;
	    		enemyButton.getLayoutParams().height = size;
	    		aliasButton.getLayoutParams().width = size;
	    		aliasButton.getLayoutParams().height = size;
	    		locationButton.getLayoutParams().width = size;
	    		locationButton.getLayoutParams().height = size;
	    		
	    		buttonBar.requestLayout();
	    	  		
	        }

			@Override
			public void onAnimationRepeat(Animation animation) {
				// TODO Auto-generated method stub
				
			}

			@Override
			public void onAnimationStart(Animation animation) {
				// TODO Auto-generated method stub
				
			}
		});
	}

	@Override
	public void onLocationChanged(Location location) {
		// TODO Auto-generated method stub
		if (location != null) {
			double lat = location.getLatitude();
			double lng = location.getLongitude();
			point = new GeoPoint((int) lat * 1000000, (int) lng * 1000000);
			mapController.animateTo(point);
		}

	}

	@Override
	public void onProviderDisabled(String provider) {
		// TODO Auto-generated method stub

	}

	@Override
	public void onProviderEnabled(String provider) {
		// TODO Auto-generated method stub

	}

	@Override
	public void onStatusChanged(String provider, int status, Bundle extras) {
		// TODO Auto-generated method stub

	}

	protected boolean isRouteDisplayed() {
		// TODO Auto-generated method stub
		return false;
	}

	private void changeStyleMotion(int oldVelocity, int velocity)
	{
		//**** changes according to movement*****//
		String message = "Sender: "+ dividedMessage[0]+"\nMessage: ";
		if (velocity == 0) 
		{
			message_text.setTextSize(15);
			informationText.setTextSize(15);
			toastImage.getLayoutParams().height = 50;
			toastImage.getLayoutParams().width = 50;
			message = message + dividedMessage[1]+dividedMessage[2]+dividedMessage[3]+dividedMessage[4];
		}
		else if (velocity == 1) 
		{
			message_text.setTextSize(20);
			informationText.setTextSize(18);
			toastImage.getLayoutParams().height = 60;
			toastImage.getLayoutParams().width = 60;
			message = message + dividedMessage[1]+dividedMessage[2]+dividedMessage[3];
		}
		else if (velocity == 2)
		{
			message_text.setTextSize(25);
			informationText.setTextSize(21);
			toastImage.getLayoutParams().height = 70;
			toastImage.getLayoutParams().width = 70;
			message = message + dividedMessage[1]+dividedMessage[2];
		}
		else if (velocity == 3)
		{
			message_text.setTextSize(30);
			informationText.setTextSize(24);
			toastImage.getLayoutParams().height = 80;
			toastImage.getLayoutParams().width = 80;
			message = message + dividedMessage[1];
			
		}
		if( velocity > oldVelocity)
			mapController.zoomIn();
		else if( velocity < oldVelocity)
			mapController.zoomOut();
		
		if(dividedMessage[0].compareTo("") != 0)
			message_text.setText(message);
	}
	
	private void changeStyleLight(int oldLight,int light)
	{
		
		//**** changes according to light condition*****//
		if(light == 0)
		{
			message_text.setTextColor(Color.BLACK);
			toast_layout.setBackgroundColor(Color.argb( 100,51,153,204));
			
			informationBar.setBackgroundColor(Color.argb( 100,51,153,204));
			informationText.setTextColor(Color.BLACK);
			
		}
		else if(light == 1)
		{
			message_text.setTextColor(Color.WHITE);
			toast_layout.setBackgroundColor(Color.argb( 200, 0, 0,0));
			
			informationBar.setBackgroundColor(Color.argb( 200, 0, 0,0));
			informationText.setTextColor(Color.WHITE);
		}
		else if(light == 2)
		{
			message_text.setTextColor(Color.rgb( 139,0,0));
			toast_layout.setBackgroundColor(Color.argb( 200, 238, 238,238));
			
			informationBar.setBackgroundColor(Color.argb( 200, 238, 238,238));
			informationText.setTextColor(Color.rgb( 139,0,0));
		}
		
		//brightness adjustment
		if(light > oldLight)
			brightness++;
		else if( light < oldLight)
			brightness --;
		
		window = getWindow();
		cResolver = getContentResolver();
		try {
			brightness = System.getInt(cResolver, System.SCREEN_BRIGHTNESS);
		} catch (SettingNotFoundException e) {
			Log.e("Error", "Cannot access system brightness");
			e.printStackTrace();
		}
		System.putInt(cResolver, System.SCREEN_BRIGHTNESS, brightness);
		LayoutParams layoutpars = window.getAttributes();
		layoutpars.screenBrightness = brightness / (float) 255;
		window.setAttributes(layoutpars);
			
	}
	
	private void addArrays(int velocity, int light)
	{
		motionArray[index] = velocity;
		lightArray[index] = light;
		index ++;
		if( index == 25)
			index = 0;
	}
	
	private int getAverage( int [] array)
	{
		int average;
		double sum = 0.0;
		for(int i = 0; i< 25; i++ )
			sum = sum + array[i];
		
		sum = sum /25;
		average = (int)Math.round(sum);
		return average;
		
	}
	
	private void changeContext()
	{
		int newMotion, newLight;
		boolean change = false;
		
		newMotion = getAverage(motionArray);
		newLight = getAverage(lightArray);
		
		if( newMotion != lastMotionValue)
		{
			changeStyleMotion(lastMotionValue, newMotion);
			decideButtons(newMotion, lastMotionValue);
			lastMotionValue = newMotion;
			change = true;		
		}
		if(newLight != lastLightValue)
		{
			changeStyleLight(lastLightValue, newLight);
			lastLightValue = newLight;
			change = true;	
		}
		
		if(change)
		{
			//**** changing map style*****/ 
			mapView.setTileSource(styles[lastLightValue][lastMotionValue]);
			change = false;
		}
	}
	
	private void decideButtons(int motionValue, int previousValue)
	{
		if(motionValue < previousValue){
			int dif = previousValue - motionValue;
			float d = 0;
			if (previousValue == 1) {
				d = (float)0.8;
				size = 70;
			} else if (previousValue == 2) {
				if(motionValue == 1){
					d = (float)0.83;
					size = 80;
				}
				else{
					d = (float)0.66;
					size = 70;
				}
			} else if (previousValue == 3) {
				if(motionValue == 2){
					d = (float)(6/7);
					size = 90;
				}
				if(motionValue == 1){
					d = (float)(5/7);
					size = 80;
				}
				else{
					d = (float)(4/7);
					size = 70;
				}
			} else;
			
			decButtonSize(d, dif);
	
		}
		else if(motionValue > previousValue){
			int dif = motionValue - previousValue;
			float d = 0;
			if (motionValue == 1) {
				d = (float)1.25;
				size = 80;
			} else if (motionValue == 2) {
				if(previousValue == 1){
					d = (float)1.2;
					size = 90;
				}
				else{
					d = (float)1.5;
					size = 90;
				}
			} else if (motionValue == 3) {
				if(previousValue == 2){
					d = (float)(7/6);
					size = 100;
				}
				if(previousValue == 1){
					d = (float)(7/5);
					size = 100;
				}
				else{
					d = (float)(7/4);
					size = 100;
				}
			} else;
			
			setButtonsSize(d, dif);
		}
	}

	private void setButtonsSize(float d ,int repeat)
	{
		int x = buttonBar.getRight();
		a = new TranslateAnimation(0, (float) (x*0.2), 0, 0);
		a.setDuration(1000);
        a.setStartOffset(200);
        
		animScale.reset();
		//animScale.setRepeatCount(repeat);
		animScale.scaleCurrentDuration(d);
		animScale.setDuration(1000);
		animScale.setInterpolator(new DecelerateInterpolator());

		buttonBar.startAnimation(animScale);

		openButtonBar.clearAnimation();
		openButtonBar.startAnimation(a);
	}
	
	private void decButtonSize(float d, int repeat){
		int x = buttonBar.getRight();
		a = new TranslateAnimation((float)(x*0.2), 0, 0, 0);
		a.setDuration(1000);
        a.setStartOffset(200);
		
		unscale.reset();
		unscale.scaleCurrentDuration(d);
		//unscale.setRepeatCount(repeat);
		unscale.setDuration(1000);
		unscale.setInterpolator(new DecelerateInterpolator());

		buttonBar.startAnimation(unscale);
		
		openButtonBar.clearAnimation();
		openButtonBar.startAnimation(a);
	}
}

// ***********Messaging Thread*************//
class MessageHandler extends Thread {

	private Handler mainHandler;

	MessageHandler(Handler mainHandler) {
		this.mainHandler = mainHandler;
		Log.i("aa", "thread created");
	}

	@Override
	public void run() {
		// Message msg = new Message();
		String message;

		Socket clientSocket;
		try {
			clientSocket = new Socket("144.122.238.144", 12012);
			BufferedReader fromServer = new BufferedReader(
					new InputStreamReader(clientSocket.getInputStream()));

			while ((message = fromServer.readLine()) != null) {

				Message msg = Message.obtain();
				msg.obj = message;
				mainHandler.sendMessage(msg);
				Log.i("child", message + "bu mesaj geldi");
			}

		} catch (UnknownHostException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}
}

class ContextControl extends Thread {

	private Handler mainHandler;

	ContextControl(Handler mainHandler) 
	{
		this.mainHandler = mainHandler;
	}

	@Override
	public void run() 
	{
		Log.i(getName(), "context control da created");
		String message;

		Socket clientSocket;
		try {
			clientSocket = new Socket("144.122.238.144", 12011);
			BufferedReader fromServer = new BufferedReader(
					new InputStreamReader(clientSocket.getInputStream()));

			while ( true ) 
			{
				char x1 =(char)fromServer.read();
				char x2 =(char)fromServer.read();
				char x3 =(char)fromServer.read();
				char [] a = { x1, x2, x3};
				message = new String(a);
				Message msg = Message.obtain();
				msg.obj = message;
				mainHandler.sendMessage(msg);
				Log.i("context", message + "bu deerler geldi");
			}

		} catch (UnknownHostException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}
}

